/*
    This file may be used for any purpose whatsoever, provided that the
    original author is never misrepresented.
  
    Coded by Bastiaan Veelo in 2004
*/

import widgets;
import dcouple.connect;
import dcouple.release;

import std.gc;

void main(char[][] arg)
{
	printf("Enter.\n");
	
	printf("Compiled with %.*s\n", dcoupleVersion() );
	
	// Some widgets. They are all top-level here, so no parents defined.
	// SpinBox has "up" and "down" slots.
	SpinBox moneyInTheBank = new SpinBox(null);
	printf("SpinBox created.\n");
	// Button has "pressed" signal.
	Button incomeButton = new Button(null);		// Button has a signal.
	Button expenseButton = new Button(null);
	ResetButton resetButton = new ResetButton(null);	// Reset has a signal with argument;
	
	// Try to be evil:
	// moneyInTheBank.up._owner = null; // Does not compile. Good.
	
	printf("Connecting.\n");
	// This syntax is possible after import dcouple.connect:
	connect(incomeButton.pressed, moneyInTheBank.up);
	// This will give a runtime warning about incompatibility:
	connect(resetButton.pressed, moneyInTheBank.up);
	
	// Alternatively, these are also equivalent:
	incomeButton.pressed.connect(moneyInTheBank.up);
	printf("step1.\n.\n");
	moneyInTheBank.up.connect(incomeButton.pressed);

	expenseButton.pressed.connect(moneyInTheBank.down);
	
	connect(resetButton.pressed,moneyInTheBank.setVal);
	resetButton.pressed.connect(moneyInTheBank.setVal);
	
	
	
	// Multiple identical connections have no effect.
	
	// Make one more connection.
	//connect(expenseButton.pressed, moneyInTheBank.down);
	
	// Some action please. Button.press() is an ordinary member function,
	// calling Signal.emit().
	incomeButton.press();
	expenseButton.press();
	
	// Explicitly disconnecting:
	//disconnect(incomeButton.pressed, moneyInTheBank.up);
	// or:
	incomeButton.pressed.disconnect(moneyInTheBank.up);
	// or:
	moneyInTheBank.up.disconnect(incomeButton.pressed);
	// Disconnecting non-existing connections has no effect.
	
	incomeButton.press(); // does nothing now.

	// Demo for the doubters:
	printf("re-connecting.\n");
	incomeButton.pressed.connect(moneyInTheBank.up);
	incomeButton.press();
	
	//disconnect(incomeButton.pressed, moneyInTheBank.up);
	
	printf("re-connecting.\n");
	moneyInTheBank.up.connect(incomeButton.pressed);
	incomeButton.press();
	
	resetButton.press();
	
	// Nastyness
	NastyWidget nasty = new NastyWidget(null);
	connect(nasty.sig,moneyInTheBank.up);
	
	//nasty.sig.connect(moneyInTheBank.up); // Compile error. Good.
	
	printf("GC\n");
	// Testing GC. This may not give the expected result, because GC code has 
	// no deterministic finalisation.
	printf("Discarding moneyInTheBank.\n");
	moneyInTheBank.discard();
	moneyInTheBank = null;
	incomeButton.press();	// Allowed, does nothing.
	printf("FULLCOLLECTING.\n");
	fullCollect();
	//connect(nasty.sig,moneyInTheBank.up); //nasty got collected! Why?
	incomeButton.press();	// Allowed, does nothing.
	
	printf("THE END.\n");
}